## cgreen 1.6.4

=== doc/CMakeLists.txt ===
FIND_PACKAGE(Asciidoctor)

SET(ASCIIDOC_CONFFILE "${PROJECT_SOURCE_DIR}/doc/cgreen_asciidoc.conf")

OPTION(CGREEN_WITH_HTML_DOCS "with HTML output" FALSE)
OPTION(CGREEN_WITH_PDF_DOCS "with PDF output" FALSE)

IF (CGREEN_WITH_HTML_DOCS AND NOT ASCIIDOCTOR_FOUND)
  MESSAGE(FATAL_ERROR "Can't produce HTML without 'asciidoctor'")
ENDIF (CGREEN_WITH_HTML_DOCS AND NOT ASCIIDOCTOR_FOUND)

IF (CGREEN_WITH_PDF_DOCS AND NOT ASCIIDOCTORPDF_FOUND)
  MESSAGE(FATAL_ERROR "Can't produce PDF without 'asciidoctor-pdf'")
ENDIF (CGREEN_WITH_PDF_DOCS AND NOT ASCIIDOCTORPDF_FOUND)

IF(CGREEN_WITH_HTML_DOCS OR CGREEN_WITH_PDF_DOCS)
  FILE(GLOB _docfiles *.asciidoc)
  FOREACH(_file ${_docfiles})
    GET_FILENAME_COMPONENT(_file_we ${_file} NAME_WE)
    SET(_in "${_file_we}")
    IF (CGREEN_WITH_HTML_DOCS)
      SET(_out "${_file_we}.html")
      ADD_CUSTOM_COMMAND(
        OUTPUT "${_out}-html"
        COMMAND ${ASCIIDOCTOR_EXECUTABLE}
        -a VERSION=${APPLICATION_VERSION}
        -o ${_out} ${_file}
        DEPENDS ${_file}
        COMMENT "asciidoctor ${_in}"
      )
      ADD_CUSTOM_TARGET(${_in}-html ALL echo
        DEPENDS "${_out}-html"
      )
    ENDIF (CGREEN_WITH_HTML_DOCS)
    IF (CGREEN_WITH_PDF_DOCS)
      SET(_out "${_file_we}.pdf")
      ADD_CUSTOM_COMMAND(
        OUTPUT "${_out}-pdf"
        COMMAND ${ASCIIDOCTORPDF_EXECUTABLE}
        -a toc
        -a VERSION=${APPLICATION_VERSION}
        -a docinfo -o ${_out} ${_file}
        DEPENDS ${_file}
        COMMENT "asciidoctor-pdf ${_in}"
      )
      ADD_CUSTOM_TARGET(${_in}-pdf ALL echo
        DEPENDS "${_out}-pdf"
      )
    ENDIF (CGREEN_WITH_PDF_DOCS)
  ENDFOREACH(_file)
ENDIF(CGREEN_WITH_HTML_DOCS OR CGREEN_WITH_PDF_DOCS)

IF(UNIX)
    set(MANPAGES man)
    INSTALL(DIRECTORY ${MANPAGES} DESTINATION share)
ENDIF(UNIX)

=== src/Makefile ===
all:
	cd ..; make --no-print-directory unit

=== tools/CMakeLists.txt ===
include_directories(${CGREEN_PUBLIC_INCLUDE_DIRS} ${PROJECT_BINARY_DIR} ${CURRENT_BINARY_DIR})

set(RUNNER_SRCS
  ${CMAKE_CURRENT_SOURCE_DIR}/cgreen-runner.c
  ${CMAKE_CURRENT_SOURCE_DIR}/gopt.c
  ${CMAKE_CURRENT_SOURCE_DIR}/gopt-errors.c
  ${CMAKE_CURRENT_SOURCE_DIR}/runner.c
  ${CMAKE_CURRENT_SOURCE_DIR}/discoverer.c
  ${CMAKE_CURRENT_SOURCE_DIR}/test_item.c
  ${CMAKE_CURRENT_SOURCE_DIR}/io.c
)
set_source_files_properties(${RUNNER_SRCS} PROPERTIES LANGUAGE C)

# Do we have an "nm"?
include(FindNm)

if (NM_FOUND)
   set_source_files_properties(discoverer.c PROPERTIES COMPILE_FLAGS -DNM_EXECUTABLE='\"${NM_EXECUTABLE}\"')

   include(DefineRelativeFilePaths)
   cmake_define_relative_file_paths("${RUNNER_SRCS}")

   add_executable(cgreen-runner ${RUNNER_SRCS})
   target_link_libraries(cgreen-runner ${CGREEN_LIBRARY} $<$<BOOL:${CGREEN_WITH_LIBXML2}>:${LIBXML2_LIBRARIES}> ${CMAKE_DL_LIBS})

   install(TARGETS cgreen-runner
     LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
     ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
     RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
     DESTINATION ${CMAKE_INSTALL_BINDIR}
   )

   install(FILES cgreen-debug
     DESTINATION ${CMAKE_INSTALL_BINDIR})

   set(CGREEN_RUNNER_TESTS_LIBRARY
     cgreen_runner_tests
     CACHE INTERNAL "cgreen-runner tests shared library"
   )
   set(RUNNER_TESTS_SRCS
     runner_unit_tests.c
     test_item.c
   )
   add_library(${CGREEN_RUNNER_TESTS_LIBRARY} SHARED ${RUNNER_TESTS_SRCS})
   target_link_libraries(${CGREEN_RUNNER_TESTS_LIBRARY} ${CGREEN_LIBRARY})

   # Due to some (of many) CMake irregularities to reference the test libraries
   # we can't just use its CMake name variable, but have to look it up with
   # some special attributes of the library:
   #     $<TARGET_FILE_DIR:the_lib>/$<TARGET_FILE_NAME:the_lib>
   #
   SET(CGREEN_RUNNER_TESTS_LIBRARY "$<TARGET_FILE_DIR:cgreen_runner_tests>/$<TARGET_FILE_NAME:cgreen_runner_tests>")

   macro_add_test(NAME cgreen_runner_unit_tests
     COMMAND cgreen-runner ${CGREEN_RUNNER_TESTS_LIBRARY})

   macro_add_test(NAME cgreen_runner_usage
     COMMAND cgreen-runner --help)

   macro_add_test(NAME cgreen_runner_quiet
     COMMAND cgreen-runner -q ${CGREEN_RUNNER_TESTS_LIBRARY})

   macro_add_test(NAME cgreen_runner_verbose
     COMMAND cgreen-runner -v -C ${CGREEN_RUNNER_TESTS_LIBRARY})

   macro_add_test(NAME cgreen_runner_version
     COMMAND cgreen-runner --version)

   macro_add_test(NAME cgreen_runner_single_explicit_named_test
     COMMAND cgreen-runner $<TARGET_FILE_DIR:cgreen_runner_tests>/$<TARGET_FILE_NAME:cgreen_runner_tests> Runner:can_match_test_name)

   macro_add_test(NAME cgreen_runner_patternmatched_testnames
     COMMAND cgreen-runner $<TARGET_FILE_DIR:cgreen_runner_tests>/$<TARGET_FILE_NAME:cgreen_runner_tests> Runner:can*)

   macro_add_test(NAME cgreen_runner_suite_name
       COMMAND cgreen-runner -s Suite ${CGREEN_RUNNER_TESTS_LIBRARY})

   macro_add_test(NAME cgreen_runner_fail_on_non_existing_library
       COMMAND cgreen-runner Suite non_existent_library)
   set_tests_properties(cgreen_runner_fail_on_non_existing_library PROPERTIES WILL_FAIL true)

   macro_add_test(NAME cgreen_runner_fail_on_non_existing_library_with_suite
       COMMAND cgreen-runner -s Suite non_existent_library
       WILL_FAIL)
   set_tests_properties(cgreen_runner_fail_on_non_existing_library_with_suite PROPERTIES WILL_FAIL true)

   macro_add_test(NAME cgreen_runner_patternmatched_testnames_in_patternmatched_context
     COMMAND cgreen-runner $<TARGET_FILE_DIR:cgreen_runner_tests>/$<TARGET_FILE_NAME:cgreen_runner_tests> Run*:can*)

   macro_add_test(NAME cgreen_runner_wildcarded_tests_in_named_context
     COMMAND cgreen-runner $<TARGET_FILE_DIR:cgreen_runner_tests>/$<TARGET_FILE_NAME:cgreen_runner_tests> Runner:*)

   macro_add_test(NAME cgreen_runner_wildcarded_tests_in_wildcarded_context
     COMMAND cgreen-runner $<TARGET_FILE_DIR:cgreen_runner_tests>/$<TARGET_FILE_NAME:cgreen_runner_tests> *:*)

   if (CGREEN_WITH_XML)
     macro_add_test(NAME cgreen_runner_with_xml_reporter
       COMMAND cgreen-runner --xml TEST --suite cgreen_runner_tests $<TARGET_FILE_DIR:cgreen_runner_tests>/$<TARGET_FILE_NAME:cgreen_runner_tests>)
   endif (CGREEN_WITH_XML)

   if (CGREEN_WITH_LIBXML2)
      macro_add_test(NAME cgreen_runner_with_libxml2_reporter
         COMMAND cgreen-runner --libxml2 TEST --suite cgreen_runner_tests $<TARGET_FILE_DIR:cgreen_runner_tests>/$<TARGET_FILE_NAME:cgreen_runner_tests>)
   endif (CGREEN_WITH_LIBXML2)

   macro_add_test(NAME cgreen_runner_multiple_libraries
     COMMAND cgreen-runner ${CGREEN_RUNNER_TESTS_LIBRARY} ${CGREEN_RUNNER_TESTS_LIBRARY} ${CGREEN_RUNNER_TESTS_LIBRARY})

else()
   message("No 'nm' found on this system. 'cgreen-runner' will not be built.")
endif()

=== tools/Makefile ===
# Makefile to run unit tests for cgreen-runner units
#
# We are using cgreen itself to test this but since the modules here
# might at some point get into the actual cgreen-runner there will be
# a clash when it loads the test library. So we will have to make the
# external symbols in the modules have other names when unittesting
# them using macro magic. The UNITTESTING preprocessor symbol will
# add the suffix '_unittesting' to externally, clashing symbols so
# that we can separate the ones in the cgreen-runner that is running
# the tests, and the ones in the units being tested.

UNAMEOEXISTS=$(shell uname -o 1>&2 2>/dev/null; echo $$?)
ifeq ($(UNAMEOEXISTS),0)
  OS=$(shell uname -o)
else
  OS=$(shell uname -s)
endif

CFLAGS = -Wall -g -I../include -MMD -DUNITTESTING -I.
ifneq ($(OS),Cygwin)
  CFLAGS+=-fPIC
endif

LDFLAGS = $(COMMONFLAGS)

LIBRARIES = -L../build/src -lcgreen

VPATH = ../src

ifeq ($(OS),Darwin)
	LD_PATH_NAME=DYLD_LIBRARY_PATH
else
	LD_PATH_NAME=LD_LIBRARY_PATH
endif

CGREEN_RUNNER = $(LD_PATH_NAME)=../build/src cgreen-runner


# Redirect to CMake build from top level
all:
	make --no-print-directory -C ..

# Use this if you want quick feed-back in this directory
tests: unit_tests acceptance_tests

#----------------------------------------------------------------------
unit unit_tests: discoverer_unit_tests runner_unit_tests
	LD_LIBRARY_PATH=. ./discoverer_unit_tests
	LD_LIBRARY_PATH=. ./runner_unit_tests

discoverer.o: CFLAGS += -DNM_EXECUTABLE='"nm"'

discoverer_unit_tests : discoverer_unit_tests.so
	$(CC) $(LDFLAGS) -o $@ $^

discoverer_unit_tests.so : discoverer_unit_test_runner.o discoverer.o test_item.o
	$(CC) $(LDFLAGS) -shared -o $@ $^ $(LIBRARIES)

# Auto-generate a runner for discoverer unittests
discoverer_unit_test_runner.c : discoverer_unit_tests.c
	echo "#include \"discoverer_unit_tests.c\"" > discoverer_unit_test_runner.c
	echo "TestSuite *discoverer_unit_tests() {" >> discoverer_unit_test_runner.c
	echo "    TestSuite *suite = create_test_suite();" >> discoverer_unit_test_runner.c
	grep Ensure discoverer_unit_tests.c | sed -e 's/Ensure(/    add_test_with_context(suite, /g' -e 's/) {/);/g' >> discoverer_unit_test_runner.c
	echo "    return suite;" >> discoverer_unit_test_runner.c
	echo "}" >> discoverer_unit_test_runner.c
	echo "int main(int argc, char **argv) {" >> discoverer_unit_test_runner.c
	echo "    return run_test_suite(discoverer_unit_tests(), create_text_reporter());" >> discoverer_unit_test_runner.c
	echo "}" >> discoverer_unit_test_runner.c

runner_unit_tests: runner_unit_tests.so
	$(CC) $(LDFLAGS) -o $@ $^ $(LIBRARIES)

runner_unit_tests.so: runner_unit_test_runner.o test_item.o
	$(CC) $(LDFLAGS) -shared -o $@ $^ -ldl $(LIBRARIES)

# Auto-generate a runner for runner unittests
runner_unit_test_runner.c : runner_unit_tests.c
	echo "#include \"runner_unit_tests.c\"" > runner_unit_test_runner.c
	echo "TestSuite *runner_unit_tests() {" >> runner_unit_test_runner.c
	echo "    TestSuite *suite = create_test_suite();" >> runner_unit_test_runner.c
	grep Ensure runner_unit_tests.c | sed -e 's/Ensure(/    add_test_with_context(suite, /g' -e 's/) {/);/g' >> runner_unit_test_runner.c
	echo "    return suite;" >> runner_unit_test_runner.c
	echo "}" >> runner_unit_test_runner.c
	echo "int main(int argc, char **argv) {" >> runner_unit_test_runner.c
	echo "    return run_test_suite(runner_unit_tests(), create_text_reporter());" >> runner_unit_test_runner.c
	echo "}" >> runner_unit_test_runner.c

#----------------------------------------------------------------------
acceptance_tests: libdiscoverer_acceptance_tests.so
	$(CGREEN_RUNNER) $^

libdiscoverer_acceptance_tests.so: discoverer_acceptance_tests.o discoverer.o test_item.o io.o
	$(CC) -shared -o $@ $^ $(LIBRARIES)

#----------------------------------------------------------------------
clean:
	-rm *.o *.so *.dll

-include *.d

=== contrib/cgreen-mocker/Makefile ===
all:
	@echo "Testing..."
	@echo -n "double... "
	@./cgreen-mocker.py double.h > double.mock
	@diff double.mock double.mock.expected
	@if [ "$$?" -eq 0 ] ; then echo "Ok" ; fi
	@echo -n "complex_types... "
	@./cgreen-mocker.py complex_types.h > complex_types.mock
	@diff complex_types.mock complex_types.mock.expected
	@if [ "$$?" -eq 0 ] ; then echo "Ok" ; fi
	@echo -n "simple_types... "
	@./cgreen-mocker.py simple_types.h > simple_types.mock
	@diff simple_types.mock simple_types.mock.expected
	@if [ "$$?" -eq 0 ] ; then echo "Ok" ; fi
	@echo -n "multiple_types... "
	@./cgreen-mocker.py multiple_types.h > multiple_types.mock
	@diff multiple_types.mock multiple_types.mock.expected
	@if [ "$$?" -eq 0 ] ; then echo "Ok" ; fi
	@echo -n "multiple_args... "
	@./cgreen-mocker.py -Da=b -Dc=d multiple_types.h > multiple_args.mock
	@diff multiple_args.mock multiple_types.mock.expected
	@if [ "$$?" -eq 0 ] ; then echo "Ok" ; fi

=== contrib/cgreen-mocker/requirements.txt ===
pycparser
packaging

=== doc/tutorial_src/Makefile ===
# This Makefile generates source and output that is part of Cgreen
# documentation. Files here are included in the asciidoc source so be
# careful with what you commit, it might thrash the documentation. In
# particular, be aware that non-UTF-8 characters in them (usually)
# makes generation of PDF impossible.  'stream2' and 'stream5' might
# generate random data as 'actual' values in the output file. That is
# the way it is supposed to be to work as documentation examples.
# Take care data for those examples is printable but looks random.

CFLAGS = -Wall -g

.IGNORE :
.SILENT :

CGREEN_ROOT=../..

# Point to MySQL includes and linking for the MySQL examples
ifeq ($(shell uname),Darwin)
MYSQL_INCLUDE = /opt/local/include/mysql56/mysql
MYSQL_LIB = /opt/local/lib/mysql56/mysql
else
ifeq ($(shell uname -o),Cygwin)
MYSQL_INCLUDE = /usr/include/mysql
MYSQL_LIB = /usr/lib
else
MYSQLROOT = /usr
MYSQL_INCLUDE = $(MYSQLROOT)/include/mysql
MYSQL_LIB = $(MYSQLROOT)/lib
endif
endif

CGREEN_BIN=$(CGREEN_ROOT)/build
CC = gcc -c -g -Wall -I$(CGREEN_ROOT)/include -I$(CGREEN_ROOT)/src -I$(MYSQL_INCLUDE) $(FPIC)
LINK = gcc -g
LIBDIRS = -L$(CGREEN_BIN)/src -L$(MYSQL_LIB)

# Enviroment dependent fixup of the various paths to use bins & libs in this development tree
FPIC = -fPIC	# required on Linux, Darwin, ...
ifeq ($(shell uname),Darwin)
LDPATH = DYLD_LIBRARY_PATH="$(CGREEN_BIN)/src:$(MYSQL_LIB)"
else
ifeq ($(shell uname -o),Cygwin)
FPIC=
LDPATH = PATH="$(CGREEN_BIN)/src:$(MYSQL_LIB)"
else
LDPATH = LD_LIBRARY_PATH="$(CGREEN_BIN)/src:$(MYSQL_LIB)"
endif
endif

RUNNER = $(LDPATH) $(CGREEN_BIN)/tools/cgreen-runner


all: with_main with_runner special
	echo
	echo "NOTE: 'stream2.out' and 'stream5.out' should contain a simulation"
	echo "NOTE: of random memory as the actual value. Don't commit changes that do"
	echo "NOTE: not. But also note that PDF generation of the documentation"
	echo "NOTE: will fail if there are non-UTF-8 characters in them."
	echo "NOTE: Edit by hand to reasonable values if needed."

# Since we have multiple files for the same tutorial example, distinguished by a number,
# we need to remove that number from all output
REMOVE_NUMBERS=-e 's/\([a-z]\)[0-9]\+\"/\1\"/' -e 's/\([a-z]\)[0-9]\+\.c/\1\.c/'

# To minimize the diffs we also need to normalize execution times
NORMALIZE_DURATION=-e 's/\ in\ [0-9]\+ms/\ in\ 42ms/g'

# And batch that together in one symbol
SED=sed $(REMOVE_NUMBERS) $(NORMALIZE_DURATION)

with_main:  first0 first1 \
		words0 words1 words2 words3 words4 words5 words6 words7 words8 words9 \
		strlen1 strlen2 strlen3 strlen4 strlen5 strlen6 strlen7 \
		double1 \
		schema1 schema2 \
		crash1 crash2 crash3 \
		suite1 \
		test_as_xml0 \
		test_as_xml1 \
		test_as_xml2 \
		test_as_xml3 \
		test_as_xml4 \
		custom_constraint1 \
		custom_constraint2 \
		custom_constraint3
	for f in $^ ; do echo $$f; $(LDPATH) ./$$f | $(SED) > $$f.out; done

# Most tests built to run with the runner we can run here, but some need special care
# They have their output produced directly in their build rules below and are run using
# the 'special' rule
with_runner: set_content side_effect stream0 stream1 stream2 stream3 stream4 stream6 \
		multiple_streams1 multiple_streams2 \
		formatter0 formatter1 formatter2 formatter3 formatter4 formatter5 formatter6 \
		struct_parameters
	for f in $^ ; do echo $$f; $(RUNNER) $$f.so | $(SED) > $$f.out; done

special: runner1 runner2 runner3 stream5 learning_mocks

clean:
	rm -f *.exe *.o *.out *.so *.stackdump *~

first_tests0.o: first_tests0.c
	$(CC) -o $@ -c $^ $(CFLAGS) -Wno-unused-variable

first0: first_tests0.o
	$(LINK) -o $@ $^ $(LIBDIRS) -lcgreen

first1: first_tests1.o
	$(LINK) -o $@ $^ $(LIBDIRS) -lcgreen

words_tests0.o: words_tests0.c
	$(CC) -o $@ -c $^ $(CFLAGS) -Wno-unused-variable

words0: all_tests.o words_tests0.o
	$(LINK) -o $@ $^ $(LIBDIRS) -lcgreen

words1: all_tests.o words_tests1.o words1.o
	$(LINK) -o $@ $^ $(LIBDIRS) -lcgreen

words2: all_tests.o words_tests1.o words2.o
	$(LINK) -o $@ $^ $(LIBDIRS) -lcgreen

words3: all_tests.o words_tests2.o words2.o
	$(LINK) -o $@ $^ $(LIBDIRS) -lcgreen

words4: all_tests.o words_tests2.o words3.o
	$(LINK) -o $@ $^ $(LIBDIRS) -lcgreen

words5: all_tests.o words_tests2.o words4.o
	$(LINK) -o $@ $^ $(LIBDIRS) -lcgreen

words6: all_tests.o words_tests3.o words5.o
	$(LINK) -o $@ $^ $(LIBDIRS) -lcgreen

words7: all_tests.o words_tests3.o words6.o
	$(LINK) -o $@ $^ $(LIBDIRS) -lcgreen

words8: all_tests.o words_tests4.o words6.o
	$(LINK) -o $@ $^ $(LIBDIRS) -lcgreen

words9: all_tests.o words_tests4.o words7.o
	$(LINK) -o $@ $^ $(LIBDIRS) -lcgreen

strlen1: strlen_tests1.o
	$(LINK) -o $@ $^ $(LIBDIRS) -lcgreen

strlen2: strlen_tests2.o
	$(LINK) -o $@ $^ $(LIBDIRS) -lcgreen

strlen3: strlen_tests3.o
	$(LINK) -o $@ $^ $(LIBDIRS) -lcgreen

strlen4: strlen_tests4.o
	$(LINK) -o $@ $^ $(LIBDIRS) -lcgreen

strlen5: strlen_tests5.o
	$(LINK) -o $@ $^ $(LIBDIRS) -lcgreen

strlen6: strlen_tests6.o
	$(LINK) -o $@ $^ $(LIBDIRS) -lcgreen

strlen7: strlen_tests7.o
	$(LINK) -o $@ $^ $(LIBDIRS) -lcgreen

double1: double_tests1.o
	$(LINK) -o $@ $^ $(LIBDIRS) -lcgreen

schema1: schema_tests1.o person.h
	$(LINK) -o $@ $^ $(LIBDIRS) -lcgreen -lmysqlclient

schema2: schema_tests2.o person.h
	$(LINK) -o $@ $^ $(LIBDIRS) -lcgreen -lmysqlclient

crash1: crash_tests1.o
	$(LINK) -o $@ $^ $(LIBDIRS) -lcgreen

crash2: crash_tests2.o
	$(LINK) -o $@ $^ $(LIBDIRS) -lcgreen

crash3: crash_tests3.o
	$(LINK) -o $@ $^ $(LIBDIRS) -lcgreen

suite1: suite1.o suite_person_tests.o suite_strlen_tests.o
	$(LINK) -o $@ $^ $(LIBDIRS) -lcgreen -lmysqlclient

test_as_xml0: test_as_xml0.o
	$(LINK) -o $@ $^ $(LIBDIRS) -lcgreen

test_as_xml1: test_as_xml1.o xml_reporter1.o
	$(LINK) -o $@ $^ $(LIBDIRS) -lcgreen

test_as_xml2: test_as_xml1.o xml_reporter2.o
	$(LINK) -o $@ $^ $(LIBDIRS) -lcgreen

test_as_xml3: test_as_xml1.o xml_reporter3.o
	$(LINK) -o $@ $^ $(LIBDIRS) -lcgreen

test_as_xml4: test_as_xml1.o xml_reporter4.o
	$(LINK) -o $@ $^ $(LIBDIRS) -lcgreen

custom_constraint1: custom_constraint1.o
	$(LINK) -o $@ $^ $(LIBDIRS) -lcgreen

custom_constraint2: custom_constraint2.o
	$(LINK) -o $@ $^ $(LIBDIRS) -lcgreen

custom_constraint3: custom_constraint3.o
	$(LINK) -o $@ $^ $(LIBDIRS) -lcgreen



###########################################################
# With runner
#
# All these examples run using the runner which automatically outputs the file name
# Since that includes the example #, which we don't want in the tutorial, we use
# sed to remove that number from the file name in the output
.PHONY: set_content
set_content: stream_tests0.o read_paragraph1.o
	$(LINK) -shared -o $@.so $^ $(LIBDIRS) -lcgreen

.PHONY: side_effect
side_effect: stream_tests0.o read_paragraph1.o
	$(LINK) -shared -o $@.so $^ $(LIBDIRS) -lcgreen

.PHONY: stream0
stream0: stream_tests0.o read_paragraph1.o
	$(LINK) -shared -o $@.so $^ $(LIBDIRS) -lcgreen

.PHONY: stream1
stream1: stream_tests1.o read_paragraph1.o
	$(LINK) -shared -o $@.so $^ $(LIBDIRS) -lcgreen

.PHONY: stream2
stream2: stream_tests2.o read_paragraph1.o
	$(LINK) -shared -o $@.so $^ $(LIBDIRS) -lcgreen

.PHONY: stream3
stream3: stream_tests2.o read_paragraph2.o
	$(LINK) -shared -o $@.so $^ $(LIBDIRS) -lcgreen

.PHONY: stream4
stream4: stream_tests3.o read_paragraph2.o
	$(LINK) -shared -o $@.so $^ $(LIBDIRS) -lcgreen

.PHONY: stream5
# This test generates random characters read from memory so we need to tidy that up
stream5: stream_tests4.o read_paragraph2.o
	$(LINK) -shared -o $@.so $^ $(LIBDIRS) -lcgreen
	$(RUNNER) $@.so | $(SED) > $@.out
	echo "Trying to remove non-characters from stream5.out"
	echo "Check manually if the following sed fails:"
	cp $@.out $@.bak && LANG='' sed -e 's/^[^[[:space:]].*"]/"]/g' $@.bak > $@.bak2 && mv $@.bak2 $@.out
	rm $@.bak

.PHONY: stream6
stream6: stream_tests4.o read_paragraph3.o
	$(LINK) -shared -o $@.so $^ $(LIBDIRS) -lcgreen

.PHONY: multiple_streams1
multiple_streams1: multiple_streams1.o
	$(LINK) -shared -o $@.so $^ $(LIBDIRS) -lcgreen

.PHONY: multiple_streams2
multiple_streams2: multiple_streams2.o
	$(LINK) -shared -o $@.so $^ $(LIBDIRS) -lcgreen

.PHONY: runner1
runner1: first_tests2.o
	$(LINK) -shared -o first_tests.so $^ $(LIBDIRS) -lcgreen
	$(RUNNER) first_tests.so | $(SED) > $@.out

.PHONY: runner2
runner2: first_tests2.o
	$(LINK) -shared -o first_tests.so $^ $(LIBDIRS) -lcgreen
	$(RUNNER) first_tests.so Cgreen:fails_this_test | $(SED) > $@.out

.PHONY: runner3
runner3: first_tests2.o
	$(LINK) -shared -o first_tests.so $^ $(LIBDIRS) -lcgreen
	$(RUNNER) -v first_tests.so Cgreen:fails_this_test | $(SED) > $@.out

.PHONY: formatter0
formatter0: stream1.o formatter_tests0.o
	$(LINK) -shared -o formatter_tests.so $^ $(LIBDIRS) -lcgreen

.PHONY: formatter1
formatter1: stream1.o formatter_tests1.o
	$(LINK) -shared -o $@.so $^ $(LIBDIRS) -lcgreen

formatter2: stream1.o formatter_tests2.o
	$(LINK) -shared -o $@.so $^ $(LIBDIRS) -lcgreen

formatter3: stream1.o formatter_tests3.o
	$(LINK) -shared -o $@.so $^ $(LIBDIRS) -lcgreen

formatter4: stream1.o formatter_tests4.o
	$(LINK) -shared -o $@.so $^ $(LIBDIRS) -lcgreen

formatter5: stream1.o formatter_tests5.o
	$(LINK) -shared -o $@.so $^ $(LIBDIRS) -lcgreen

formatter6: stream2.o formatter_tests5.o
	$(LINK) -shared -o $@.so $^ $(LIBDIRS) -lcgreen

struct_parameters: struct_parameters.o
	$(LINK) -shared -o $@.so $^ $(LIBDIRS) -lcgreen

learning_mocks: learning_mocks.o
	$(LINK) -shared -o $@.so $^ $(LIBDIRS) -lcgreen
	$(RUNNER) $@.so

=== debian/changelog ===
cgreen (1.6.4-3) unstable; urgency=medium

  * d/control: replace asciidoctor-pdf with asciidoctor.
  * d/doc: install the locally generated HTML guide.
  * d/doc-base: reference the HTML guide.
  * d/rules: disable PDF docs and strip remote assets from HTML build.

 -- Gavin Lai (賴建宇) <gavin09@gmail.com>  Sat, 01 Nov 2025 09:51:44 +0800

cgreen (1.6.4-2) unstable; urgency=medium

  * d/control:
    - Change Build-Depends from ruby-asciidoctor-pdf to asciidoctor-pdf
      (Closes: #1114079, #1112773)
    - Bump Standards-Version to 4.7.2
  * d/watch: Upgrade to version 5 format.
  * Add patch to fix uninitialized value in make_cgreen_integer_value

 -- Gavin Lai (賴建宇) <gavin09@gmail.com>  Fri, 05 Sep 2025 13:56:19 +0800

cgreen (1.6.4-1) unstable; urgency=medium

  * Upload to unstable

 -- Gavin Lai (賴建宇) <gavin09@gmail.com>  Sun, 16 Feb 2025 22:57:46 +0800

cgreen (1.6.4-1~exp1) experimental; urgency=medium

  * Import new upstream release
  * d/control: Bump Standards-Version to 4.7.0

 -- Gavin Lai (賴建宇) <gavin09@gmail.com>  Fri, 31 Jan 2025 00:26:35 +0800

=== debian/control ===
Source: cgreen
Section: libs
Priority: optional
Maintainer: Gavin Lai (賴建宇) <gavin09@gmail.com>
Uploaders: SZ Lin (林上智) <szlin@debian.org>
Build-Depends: cmake, libxml2-dev, asciidoctor, debhelper-compat (= 13)
Standards-Version: 4.7.2
Homepage: https://github.com/cgreen-devs/cgreen
Rules-Requires-Root: no
Vcs-Browser: https://salsa.debian.org/debian/cgreen
Vcs-Git: https://salsa.debian.org/debian/cgreen.git

Package: libcgreen1-dev
Section: libdevel
Architecture: any
Depends: libcgreen1 (=${binary:Version}), ${misc:Depends}
Description: Cgreen library - development files
 A modern unit test and mocking framework for C and C++. Cgreen features
    - fast build, clean code, highly portable
    - simple auto-discovery of tests
    - fluent, expressive and readable API
    - each test runs in isolation to prevent cross-test dependencies
    - built-in mocking for C, compatible other C++ mocking libraries

Package: libcgreen1
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Cgreen Library - Unit tests and mocking framework for C and C++
 A modern unit test and mocking framework for C and C++. Cgreen features
    - fast build, clean code, highly portable
    - simple auto-discovery of tests
    - fluent, expressive and readable API
    - each test runs in isolation to prevent cross-test dependencies
    - built-in mocking for C, compatible other C++ mocking librarie
 Provides the Unittest library

Package: libcgreen1-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Description: Cgreen Library - document
 A modern unit test and mocking framework for C and C++. Cgreen features
    - fast build, clean code, highly portable
    - simple auto-discovery of tests
    - fluent, expressive and readable API
    - each test runs in isolation to prevent cross-test dependencies
    - built-in mocking for C, compatible other C++ mocking librarie
 Provides the Unittest library document

Package: cgreen1
Section: utils
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Recommends: libcgreen1-dev
Description: Cgreen Library - Library tool
 A modern unit test and mocking framework for C and C++. Cgreen features
    - fast build, clean code, highly portable
    - simple auto-discovery of tests
    - fluent, expressive and readable API
    - each test runs in isolation to prevent cross-test dependencies
    - built-in mocking for C, compatible other C++ mocking librarie
 Provides the Unittest test tool

=== debian/rules ===
#!/usr/bin/make -f

DPKG_EXPORT_BUILDFLAGS = 1
# Disable fixfilepath as it triggers build failures.
export DEB_BUILD_MAINT_OPTIONS := hardening=+all reproducible=-fixfilepath
export DEB_CFLAGS_MAINT_APPEND := -Wall -D_FORTIFY_SOURCE=2 -O1
SRC	:= $(CURDIR)
BUILD	:= $(SRC)/build
TARGET	:= $(SRC)/debian/tmp

%:
	dh $@

override_dh_auto_test:
	if ! LD_LIBRARY_PATH="$(BUILD)/src/" dh_auto_test; then \
		cat $(BUILD)/Testing/Temporary/LastTest.log; \
		exit 1; \
	fi

override_dh_auto_configure:
	[ -d $(BUILD) ] || mkdir $(BUILD)
	cd $(BUILD) && cmake $(CURDIR) -DCMAKE_INSTALL_PREFIX="/usr" \
		-DCMAKE_C_FLAGS="${CFLAGS} $(DEB_CFLAGS_MAINT_APPEND) -fzero-init-padding-bits=unions" \
		-DCMAKE_SKIP_RPATH=ON \
		-DCMAKE_VERBOSE_MAKEFILE=ON \
		-DLIB_INSTALL_DIR=/usr/lib \
		-DCGREEN_WITH_PDF_DOCS:bool=FALSE
	touch configure-stamp

override_dh_auto_build:
	dh_auto_build
	mkdir -p $(BUILD)/doc
	asciidoctor -a docinfo -a linkcss! -a icons! -a source-highlighter! -a webfonts! \
		-o $(BUILD)/doc/cgreen-guide-en.html doc/cgreen-guide-en.asciidoc

override_dh_clean:
	rm -f configure-stamp build-stamp gitrevision.h
	rm -rf $(BUILD)
	dh_clean

=== debian/tests/control ===
Tests: testsuite
Restrictions: allow-stderr, superficial
Depends: @

Tests: run-cgreen-test
Restrictions: allow-stderr
Depends: @, build-essential

=== debian/watch ===
Version: 5

Source: https://github.com/cgreen-devs/cgreen/tags
Matching-Pattern: .*/v?(\d\S*)\.tar\.gz
Filenamemangle: s/.+\/v?(\d\S*)\.tar\.gz/cgreen-$1\.tar\.gz/
